package cn.ibizlab.businesscentral.core.sales.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import com.alibaba.fastjson.JSONObject;
import org.springframework.cache.annotation.CacheEvict;

import cn.ibizlab.businesscentral.core.sales.domain.Discount;
import cn.ibizlab.businesscentral.core.sales.filter.DiscountSearchContext;


import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[Discount] 服务对象接口
 */
public interface IDiscountService extends IService<Discount>{

    Discount get(String key) ;
    boolean checkKey(Discount et) ;
    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    boolean create(Discount et) ;
    void createBatch(List<Discount> list) ;
    Discount getDraft(Discount et) ;
    boolean update(Discount et) ;
    void updateBatch(List<Discount> list) ;
    boolean save(Discount et) ;
    void saveBatch(List<Discount> list) ;
    Page<Discount> searchDefault(DiscountSearchContext context) ;
    List<Discount> selectByDiscounttypeid(String discounttypeid) ;
    void removeByDiscounttypeid(String discounttypeid) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

    List<Discount> getDiscountByIds(List<String> ids) ;
    List<Discount> getDiscountByEntities(List<Discount> entities) ;

}


